#!/usr/bin/php
<?php
if (isset($_SERVER['REMOTE_ADDR'])) {
    die('Direct access not permitted');
}
// This script will output --virtuals and estimated-- W in/out and self-consumption counters into a meterN compatible format
// It is simply based on your household's production and consumption real meters.
// The self-consumption estimation is only valid if the consumption and production is on the same phase.
// ln -s /var/www/metern/comapps/eflowlive.php /usr/bin/eflowlive
// eflowlive [ whout | whin | selfc ]

$pathto123s = '/var/www/123solar';
$invtnum1   = 1;
$consmet    = 2;

// Setup your virtual meters identification numbers:
$whinmet  = 3; // Meter ID Prelievi (Whin)
$whoutmet = 4; // Meter ID Immissioni (Whout) 
$selfcmet = 5; // Meter ID Autoconsumo (selfc)

// No edit is needed below
if (!isset($argv[1])) {
	$argv[1]=null;
}
if ($argv[1]== 'whout' || $argv[1]=='whin' || $argv[1]=='selfc') {

	define('checkaccess', TRUE);
	include("$pathto123s/config/config_main.php");
	include("$pathto123s/config/config_invt$invtnum1.php");
	include("$pathto123s/scripts/memory.php");

    include('/var/www/metern/config/config_main.php');
	include("/var/www/metern/config/config_met$consmet.php");
	date_default_timezone_set($DTZ);

	@$shmid = shmop_open($LIVEMEMORY, 'a', 0, 0);
	if (!empty($shmid)) {
		$size = shmop_size($shmid);
		shmop_close($shmid);
		
		@$shmid = shmop_open($LIVEMEMORY, 'c', 0644, $size);
		if (!empty($shmid)) {
			$data = shmop_read($shmid, 0, $size);
			shmop_close($shmid);
			$memarray = json_decode($data, true);
			
			$nowUTC = strtotime(date("Ymd H:i:s")); // inverter 1
			if ($nowUTC - $memarray["SDTE$invtnum1"] < 30) {
				$GP1 = $memarray["G1P$invtnum1"] + $memarray["G2P$invtnum1"] + $memarray["G3P$invtnum1"];
			} else { // Too old
				$GP1 = 0;
			}
			$GP = $GP1; // Totale Potenza
			if ($GP > 1000) {
					$GP = round($GP, 0);
				} else {
					$GP = round($GP, 1);
				}
		}
	}

	if (empty($shmid)) { // 123s ain't running
		$GP = 0;
	}

	// Now recupero valore consumo
	$cmd = "more /run/shm/metern$consmet.txt | egrep \"^$consmet\(\" | grep \"*W)\""; // Request Power values
	$datareturn = shell_exec($cmd);
	$datareturn = trim($datareturn);
	$datareturn = preg_replace("/^${'ID'.$consmet}\(/i", '', $datareturn); // VALUE*UNIT)
	$cons_val_live = preg_replace("/\*[a-z0-9]+\)$/i", '', $datareturn); // VALUE
	#echo "$cons_val_live\n";

	$housep = $GP;
	$housec = $cons_val_live;

	if ($argv[1] == 'whout') { // immissioni
		$val = $housep - $housec;
		if ($val < 0) {
			$val = 0;
		}
		$id = $whoutmet;
	}
				
	if ($argv[1] == 'whin') { // prelievi
		$val = $housec - $housep;
		if ($val < 0) {
			$val = 0;
		}
		$id = $whinmet;
	}
					
	if ($argv[1] == 'selfc') { // autoconsumo
		if ($housep > $housec) {
			$val = $housec;
		} else {
			$val = $housep;
		}
		$id = $selfcmet;
	}
	settype($val, 'float');

	$val = round($val, ${'PRECI' . $consmet});
    $str = utf8_decode("$id($val*W)\n");
	echo "$str";
} else {
	die("Usage: eflowlive { whout | whin | selfc }\n");
}
?>